--- ./include/asterisk/chanvars.h.bak	2016-01-23 05:28:40.914311501 +0300
+++ ./include/asterisk/chanvars.h	2016-01-23 05:35:32.448461680 +0300
@@ -28,7 +28,7 @@
 struct ast_var_t {
 	AST_LIST_ENTRY(ast_var_t) entries;
 	char *value;
-	char name[0];
+	char *name;
 };
 
 AST_LIST_HEAD_NOLOCK(varshead, ast_var_t);
--- ./main/chanvars.c.bak	2016-01-23 05:28:34.884251138 +0300
+++ ./main/chanvars.c	2016-01-23 06:14:41.508153524 +0300
@@ -42,26 +42,28 @@
 #endif
 {
 	struct ast_var_t *var;
-	int name_len = strlen(name) + 1;
-	int value_len = strlen(value) + 1;
+
+	if (!name || !value)
+		return NULL;
 
 #ifdef MALLOC_DEBUG
-	if (!(var = __ast_calloc(sizeof(*var) + name_len + value_len, sizeof(char), file, lineno, function))) {
+	if (!(var = __ast_calloc(1, sizeof(*var), file, lineno, function))) {
 #else
-	if (!(var = ast_calloc(sizeof(*var) + name_len + value_len, sizeof(char)))) {
+	if (!(var = ast_calloc(1, sizeof(*var)))) {
 #endif
 		return NULL;
 	}
 
-	ast_copy_string(var->name, name, name_len);
-	var->value = var->name + name_len;
-	ast_copy_string(var->value, value, value_len);
+	var->value = ast_strdup(value);
+	var->name = ast_strdup(name);
 
 	return var;
 }
 
 void ast_var_delete(struct ast_var_t *var)
 {
+	ast_free(var->value);
+	ast_free(var->name);
 	ast_free(var);
 }
 
